#!/usr/bin/python3

# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="dialog", stop_implicitly_when_browser_closed=True)
        self.dlg = None
        self.numberds = self.create_datastore()
        self.numberds.setvalue(0)
        self.setbodyleft(yaji.View('Button', label="Open dialog",
                                   OnClicked=self.bindevent(yaji.BackendFunction('foo'))))
        self.setbodyright(yaji.View(label=self.binddata(self.numberds)))

    @yaji.RequestHandler.for_urls(auto=True)
    @yaji.RequestHandler.run_downstream()
    def _do_foo(self):
        if not self.dlg:
            self.dlg = self.create_dialog(yaji.View('Dialog', title="My Dialog", body=yaji.HorizontalStack(
                yaji.View(label="Please choose: "),
                yaji.View('Button', label="-", OnClicked=self.bindevent(yaji.BackendFunction('number_dec'))),
                yaji.View('Button', label="+", OnClicked=self.bindevent(yaji.BackendFunction('number_inc'))),
                yaji.View('Button', label="close", OnClicked=self.bindevent(yaji.BackendFunction('foo_close'))),
            )))
            def _thankyoumsg():
                self.userfeedback.messagedialog("Thank you for using my dialog!")
                self.dlg = None
            self.dlg.add_closed_handler(_thankyoumsg)
            self.dlg.show()

    @yaji.RequestHandler.for_urls(auto=True)
    @yaji.RequestHandler.run_downstream()
    def _do_foo_close(self):
        if self.dlg:
            self.dlg.close()

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_number_inc(self):
        self.numberds.setvalue(self.numberds.getvalue() + 1)

    @yaji.RequestHandler.for_urls(auto=True)
    def _do_number_dec(self):
        self.numberds.setvalue(self.numberds.getvalue() - 1)


if __name__ == '__main__':
    Application().start()
