#!/usr/bin/python3

# Copyright (C) 2014-2021, Josef Hahn
#
# This file is part of Yaji.
#
# Yaji is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Yaji is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Yaji.  If not, see <http://www.gnu.org/licenses/>.

import ___sampleapp  # this is just an internal hack - just ignore it and don't copy it!

import yaji


class Application(yaji.Application):

    def __init__(self):
        super().__init__(head1="Yaji Sample", head2="layouting", stop_implicitly_when_browser_closed=True)
        self.setbodyleft(yaji.ScrollView(yaji.VerticalStack(

            yaji.View(label="HorizontalStack", style="font-size:1.4em"),
            yaji.HorizontalStack(
                yaji.View('Button', label='foo'),
                yaji.Spacer(width='3pt'),
                yaji.View('Button', label='bar'),
                yaji.View('Button', label='baz'),
            ),

            yaji.View(label="VerticalStack", style="font-size:1.4em"),
            yaji.VerticalStack(
                yaji.View('Button', label='foo'),
                yaji.View('Button', label='bar'),
                yaji.Spacer(height='3pt'),
                yaji.View('Button', label='baz'),
            ),

            yaji.View(label="Grid", style="font-size:1.4em"),
            yaji.Grid(
                yaji.View('Button', label='foo', row=2, col=0),
                yaji.Spacer(height='10pt', row=1),
                yaji.View('Button', label='bar', row=0, col=1),
                yaji.Spacer(height='10pt', row=3),
                yaji.View('Button', label='baz', row=4, col=2),
                yaji.View('Button', label='moo', row=2, col=3),
            ),

            yaji.View(label="Wrap", style="font-size:1.4em"),
            yaji.Wrap(
                yaji.View('Button', label='foo'),
                yaji.View('Button', label='bar'),
                yaji.View('Button', label='baz'),
                yaji.View('Button', label='foo foo'),
                yaji.View('Button', label='foo bar'),
                yaji.View('Button', label='foo baz'),
                yaji.View('Button', label='bar foo'),
                yaji.View('Button', label='bar bar'),
                yaji.View('Button', label='bar baz'),
                yaji.View('Button', label='baz foo'),
                yaji.View('Button', label='baz bar'),
                yaji.View('Button', label='baz baz'),
            ),

        ), width='200pt'))


if __name__ == '__main__':
    Application().start()
